//+------------------------------------------------------------------+
//|                                              EqualVolumeBars.mq4 |
//|                                      Copyright  2008, komposter |
//|                                      mailto:komposterius@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, komposter"
#property link      "mailto:komposterius@mail.ru"

#include <WinUser32.mqh>

//----     
extern int		TicksInBar	= 2;
extern int		StartYear	= 2008;
extern int		StartMonth	= 01;

int HistoryHandle = -1, HistoryFilePos = 0, hwnd = 0, TicksFilePos = 0, now_time;
double now_close, now_open, now_low, now_high, now_volume;
string _Symbol;

int _Period, _PeriodSec, pre_time, last_fpos = 0;
double pre_close;

int init()
{
	int    _GetLastError = 0, cnt_ticks = 0, cnt_bars = 0, temp[13];

	//   ,    off-line 
	_Symbol = Symbol();
   hwnd = 0;

	//  ,     
	string file_name = StringConcatenate( "!Eqv", _Symbol, TicksInBar, ".hst" );
	HistoryHandle = FileOpenHistory( file_name, FILE_BIN | FILE_WRITE );
	if ( HistoryHandle < 0 )
	{
		_GetLastError = GetLastError();
		Alert( "FileOpenHistory( \"", file_name, "\", FILE_BIN | FILE_WRITE )", " - Error #", _GetLastError );
		return(-1);
	}

	//----   
	FileWriteInteger	( HistoryHandle, 400, LONG_VALUE );
	FileWriteString	( HistoryHandle, "Copyright  2008, komposter", 64 );
	FileWriteString	( HistoryHandle, StringConcatenate( "!Eqv", _Symbol ), 12 );
	FileWriteInteger	( HistoryHandle, TicksInBar, LONG_VALUE );
	FileWriteInteger	( HistoryHandle, Digits, LONG_VALUE );
	FileWriteInteger	( HistoryHandle, 0, LONG_VALUE );       //timesign
	FileWriteInteger	( HistoryHandle, 0, LONG_VALUE );       //last_sync
	FileWriteArray		( HistoryHandle, temp, 0, 13 );

	//+------------------------------------------------------------------+
	//|  
	//+------------------------------------------------------------------+
	int year = StartYear, month = StartMonth;
	int cur_date = year*100+month, end_date = Year()*100+Month();

	datetime time; double bid; string tmp_str1, tmp_str2;
	now_time = 60; now_close = 0; now_open = 0; now_low = 0; now_high = 0; now_volume = 0;

	while ( cur_date <= end_date )
	{
		string ticks_file_name = StringConcatenate( "[Ticks]\\", AccountServer(), "\\", Symbol(), "_", year, ".", strMonth( month ), ".csv" );
		int ticks_file_handle = FileOpen( ticks_file_name, FILE_READ | FILE_CSV );

		//----   
		if ( ticks_file_handle < 0 )
		{
			Alert( "    \"", ticks_file_name, "\" #", GetLastError(), "!" );
		}
		else
		{
			while ( !FileIsEnding( ticks_file_handle ) )
			{
				if ( GetLastError() == 4099 ) break;

				tmp_str1 = FileReadString( ticks_file_handle );
				if ( StringLen( tmp_str1 ) < 19 ) continue;

				tmp_str2 = FileReadString( ticks_file_handle );
				if ( StringLen( tmp_str2 ) < Digits+2 ) continue;

				time = StrToTime  ( tmp_str1 );
				bid  = StrToDouble( tmp_str2 );

				//     
				if ( now_volume >= TicksInBar || now_volume < 1 )
				{
					if ( now_volume >= TicksInBar )
					{
						FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
						FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
						FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
						FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
						FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
						FileWriteDouble	( HistoryHandle, now_volume,	DOUBLE_VALUE);
						FileFlush			( HistoryHandle );

						cnt_bars ++;
					}

					//now_time		= time;
					now_time		+= 60;	//   ,    2    
					now_open		= bid;
					now_low		= bid;
					now_high		= bid;
					now_close	= bid;
					now_volume	= 1;
				}
				else
				{
					if ( bid < now_low  ) now_low  = bid;
					if ( bid > now_high ) now_high = bid;
					now_close = bid;
					now_volume ++;
				}
				cnt_ticks ++;
			}

			//----  
			FileClose( ticks_file_handle );
			GetLastError();
		}

		month ++;
		if ( month > 12 )
		{
			month = 1;
			year ++;
		}
		cur_date = year*100+month;
	}


	//    ,   0- 
	HistoryFilePos = FileTell( HistoryHandle);

	//  0-     
	FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
	FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_volume,	DOUBLE_VALUE);
	FileFlush			( HistoryHandle );

	//  
	Print( "< - - -  : ", cnt_ticks, ",   : ", cnt_bars, " - - - >" );
	Print( "< - - -      \"!Eqv", _Symbol, TicksInBar, "\" - - - >" );
	
	//  
	RefreshWindow();

	return(0);
}

int start()
{
	if ( HistoryHandle < 0 ) return(-1);
   double Bid_=MarketInfo("GBPUSD",MODE_BID)-MarketInfo("EURUSD",MODE_BID);
	//+------------------------------------------------------------------+
	//|   
	//+------------------------------------------------------------------+
	//----  ""   
	FileSeek( HistoryHandle, HistoryFilePos, SEEK_SET );

	now_volume ++;

	//  
	if ( now_volume <= TicksInBar )
	{
		if ( Bid_ < now_low  ) now_low  = Bid_;
		if ( Bid_ > now_high ) now_high = Bid_;
		now_close = Bid_;

		//  0-     
		FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
		FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_volume,	DOUBLE_VALUE);
		FileFlush			( HistoryHandle );
	}
	//    
	else
	{
		//  1- 
		FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
		FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_volume-1,DOUBLE_VALUE);
		FileFlush			( HistoryHandle );

//		now_time		= TimeCurrent();
		now_time		+= 60;	//   ,    2    
		now_open		= Bid_;
		now_low		= Bid_;
		now_high		= Bid_;
		now_close	= Bid_;
		now_volume	= 1;

		//    ,   0- 
		HistoryFilePos = FileTell( HistoryHandle);

		//  0- 
		FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
		FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_volume,	DOUBLE_VALUE);
		FileFlush			( HistoryHandle );
	}
/*
// Print( "now_time = ", now_time, ", now_open = ", now_open, ", now_low = ", now_low, ", now_high = ", now_high, ", now_close = ", now_close, ", now_volume = ", now_volume );
// Print( "5:  file_pos = ", FileTell( HistoryHandle) );
	//     
	FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
	FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
	FileWriteDouble	( HistoryHandle, now_volume,	DOUBLE_VALUE);
	FileFlush			( HistoryHandle );

// Print( "6:  file_pos = ", FileTell( HistoryHandle) );
*/
	//  
	RefreshWindow();
}

void RefreshWindow()
{
	//----  ,    ""  
	if ( hwnd == 0 )
	{
		hwnd = WindowHandle( StringConcatenate( "!Eqv", _Symbol ), TicksInBar );
		if ( hwnd != 0 ) { Print( "< - - -  ", "!Eqv", _Symbol, TicksInBar, " ! - - - >" ); }
	}
	//---- ,  ,  
	if ( hwnd != 0 ) { PostMessageA( hwnd, WM_COMMAND, 33324, 0 ); }
}

int deinit()
{
	if ( HistoryHandle > 0 )
	{
		//----  
		FileClose( HistoryHandle );
		HistoryHandle = -1;
	}
	return(0);
}

string strMonth( int m )
{
	if ( m < 10 ) return( StringConcatenate( "0", m ) );
	return(m);
}